'use strict';

var _chai = require('chai');

var _createSubject = require('../createSubject');

var _createSubject2 = _interopRequireDefault(_createSubject);

var _createBehaviorSubject = require('../createBehaviorSubject');

var _createBehaviorSubject2 = _interopRequireDefault(_createBehaviorSubject);

var _switch = require('../switch');

var _switch2 = _interopRequireDefault(_switch);

var _test = require('../test');

var _test2 = _interopRequireDefault(_test);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('switch', function () {
  it('should work', function () {
    var outer, subj1, subj2, subj3, switched;
    subj1 = (0, _createSubject2.default)();
    subj2 = (0, _createSubject2.default)();
    subj3 = (0, _createSubject2.default)();
    outer = (0, _createSubject2.default)();
    switched = (0, _switch2.default)(outer);
    (0, _test2.default)(switched, console.log.bind(console), [function (x) {
      return x === 1;
    }, function (x) {
      return x === 2;
    }, function (x) {
      return x === 3;
    }, 'complete', 'failure']);
    outer.next(subj1);
    subj1.next(1);
    outer.next(subj2);
    subj2.next(2);
    outer.next(subj3);
    outer.complete();
    subj3.next(3);
    return subj3.complete();
  });
  it('should work with BehaviorSubject', function () {
    var outer, subj1, subj2, subj3, switched;
    subj1 = (0, _createBehaviorSubject2.default)();
    subj1.next(1);
    subj2 = (0, _createBehaviorSubject2.default)();
    subj2.next(2);
    subj3 = (0, _createBehaviorSubject2.default)();
    subj3.next(3);
    outer = (0, _createSubject2.default)();
    switched = (0, _switch2.default)(outer);
    (0, _test2.default)(switched, console.log.bind(console), [function (x) {
      return x === 1;
    }, function (x) {
      return x === 2;
    }, function (x) {
      return x === 3;
    }, 'complete', 'failure']);
    outer.next(subj1);
    outer.next(subj2);
    return outer.next(subj3);
  });
  return it('should manage subscriptions properly', function () {
    var outer, sub, subj1, subj2, switched;
    subj1 = (0, _createSubject2.default)({
      onObserversChanged: function (obs, added, removed) {
        return console.log("subj1 observers", obs, "added", added, "removed", removed);
      }
    });
    subj2 = (0, _createSubject2.default)({
      onObserversChanged: function (obs, added, removed) {
        return console.log("subj2 observers", obs, "added", added, "removed", removed);
      }
    });
    outer = (0, _createSubject2.default)();
    switched = (0, _switch2.default)(outer);
    sub = switched.subscribe(function () {});
    outer.next(subj1);
    outer.next(subj2);
    return sub.unsubscribe();
  });
}); // Generated by CoffeeScript 1.12.7