'use strict';

exports.__esModule = true;

var _subscribeObserverAdapter = require('./subscribeObserverAdapter');

var _subscribeObserverAdapter2 = _interopRequireDefault(_subscribeObserverAdapter);

var _defineObservable = require('./defineObservable');

var _defineObservable2 = _interopRequireDefault(_defineObservable);

var _createSubscription = require('./createSubscription');

var _createSubscription2 = _interopRequireDefault(_createSubscription);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 1.12.7
var merge;

exports.default = merge = function (observables, observableConstructor) {
  var count, subscribe;
  count = observables.length;
  subscribe = (0, _subscribeObserverAdapter2.default)(function (observer) {
    var active, complete, error, next, sub, subscribeOne, subscriptions, unsubscribeAll;
    active = count;
    subscriptions = [];
    unsubscribeAll = function () {
      var i, len, subscription;
      for (i = 0, len = subscriptions.length; i < len; i++) {
        subscription = subscriptions[i];
        if (typeof subscription.unsubscribe === "function") {
          subscription.unsubscribe();
        }
      }
    };
    error = function (err) {
      if (active === 0) {
        return;
      }
      active = 0;
      unsubscribeAll();
      return typeof observer.error === "function" ? observer.error(err) : void 0;
    };
    complete = function () {
      if (active === 0) {
        return;
      }
      if (--active === 0) {
        unsubscribeAll();
        return typeof observer.complete === "function" ? observer.complete() : void 0;
      }
    };
    next = function (x) {
      if (active !== 0) {
        return typeof observer.next === "function" ? observer.next(x) : void 0;
      }
    };
    subscribeOne = function (observable) {
      return subscriptions.push(observable.subscribe({
        next: next,
        complete: complete,
        error: error
      }));
    };
    observables.forEach(subscribeOne);
    sub = (0, _createSubscription2.default)(observer, unsubscribeAll);
    if (typeof observer.start === "function") {
      observer.start(sub);
    }
    return sub;
  });
  return (0, _defineObservable2.default)({
    subscribe: subscribe
  });
};