'use strict';

exports.__esModule = true;

var _defineObservable = require('./defineObservable');

var _defineObservable2 = _interopRequireDefault(_defineObservable);

var _subscribeObserverAdapter = require('./subscribeObserverAdapter');

var _subscribeObserverAdapter2 = _interopRequireDefault(_subscribeObserverAdapter);

var _createSubscription = require('./createSubscription');

var _createSubscription2 = _interopRequireDefault(_createSubscription);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 1.12.7
var _switch;

exports.default = _switch = function (priorObservable, opts) {
  var subscribe;
  subscribe = (0, _subscribeObserverAdapter2.default)(function (observer) {
    var error, hasCompleted, innerSubscription, isStopped, outerSubscription, unsubscribeInner;
    innerSubscription = null;
    isStopped = false;
    hasCompleted = false;
    unsubscribeInner = function () {
      if (innerSubscription) {
        innerSubscription.unsubscribe();
        return innerSubscription = null;
      }
    };
    error = function (err) {
      isStopped = true;
      unsubscribeInner();
      return typeof observer.error === "function" ? observer.error(err) : void 0;
    };
    outerSubscription = priorObservable.subscribe({
      next: function (innerObservable) {
        unsubscribeInner();
        innerSubscription = innerObservable.subscribe({
          next: function (value) {
            if (!isStopped) {
              return typeof observer.next === "function" ? observer.next(value) : void 0;
            }
          },
          error: error,
          complete: function () {
            unsubscribeInner();
            if (hasCompleted) {
              isStopped = true;
              return typeof observer.complete === "function" ? observer.complete() : void 0;
            }
          }
        });
      },
      error: error,
      complete: function () {
        hasCompleted = true;
        if (!innerSubscription) {
          isStopped = true;
          return typeof observer.complete === "function" ? observer.complete() : void 0;
        }
      }
    });
    return (0, _createSubscription2.default)(observer, function () {
      unsubscribeInner();
      return outerSubscription.unsubscribe();
    });
  });
  return (0, _defineObservable2.default)({
    subscribe: subscribe
  });
};