"use strict";

exports.__esModule = true;
// Generated by CoffeeScript 1.12.7
var test;

exports.default = test = function (observable, always, expectations) {
  var currentIndex, nextSubscr, subscr;
  currentIndex = 0;
  subscr = observable.subscribe({
    start: function () {
      if (typeof always === "function") {
        always('start');
      }
      if (currentIndex > 0) {
        throw new Error("Got value before start");
      }
      return currentIndex = 0;
    },
    next: function (x) {
      var name;
      if (typeof always === "function") {
        always('next', x);
      }
      if (!(typeof expectations[name = currentIndex++] === "function" ? expectations[name](x) : void 0)) {
        throw new Error("Expectation[" + (currentIndex - 1) + "] failed.");
      }
    },
    complete: function () {
      if (typeof always === "function") {
        always('complete');
      }
      if (!(expectations[currentIndex++] === 'complete')) {
        throw new Error("Unexpected completion at " + currentIndex);
      }
    },
    error: function (err) {
      if (typeof always === "function") {
        always('error', err);
      }
      if (!(expectations[currentIndex++] === 'error')) {
        throw new Error("Unexpected error at " + currentIndex);
      }
    }
  });
  return nextSubscr = {
    unsubscribe: function () {
      if (currentIndex < expectations.length) {
        throw new Error("Leftover expectations");
      }
      return subscr.unsubscribe();
    }
  };
};